#include "AnmeldungServer.h"
#include <Zeit.h>
#include <iostream>
#include <fstream>
#include <Globals.h>
#include <sys/socket.h>
#include <sys/resource.h>

int main()
{
	struct rlimit core_limits;
	core_limits.rlim_cur = core_limits.rlim_max = RLIM_INFINITY;
	setrlimit(RLIMIT_CORE, &core_limits);
#ifdef DEBUG
    chdir( "/test/anmeldung" );
#endif
    Framework::initFramework();
    Zeit *z = getZeit();
    Text *pfad = new Text( "../log/anmeldung/" );
    pfad->append( z->getZeit( "y-m-d h-i-s.log" ) );
    z->release();
    DateiPfadErstellen( pfad->getThis() );
    std::ofstream file;
    file.open( pfad->getText() );
    std::streambuf* sbuf = std::cout.rdbuf();
    std::cout.rdbuf( file.rdbuf() );
    pfad->release();

    std::cout << "AS: Startet...\n";
    std::cout << "AS: Lese init Datei ../data/asInit.ini ...\n";
    InitDatei *dat = new InitDatei( "../data/asInit.ini" );
    if( !dat->laden() )
    {
        std::cout << "AS: error: Datei konnte nicht gelesen werden. Das Programm wird geschlossen.\n";
        dat->release();
        exit( 1 );
    }
    const char *wichtig[] = { "ServerId", "DBBenutzer", "DBPasswort", "DBName", "DBIP", "DBPort", "Aktiv" };
    for( const char *w : wichtig )
    {
        if( !dat->wertExistiert( w ) )
        {
            std::cout << "AS: error: Der Wert '" << w << "' wurde nicht gefunden. Das Programm wird geschlossen.\n";
            dat->release();
            exit( 1 );
        }
    }

    AnmeldungServer *aServer = new AnmeldungServer( dat );

    std::cout << "AS: Der Admin Server läuft. Startforgang beendet.\n";
    aServer->runn();

    aServer->ende();
    aServer->release();
    dat->release();
    std::cout << "AS: Der Server ist heruntergefahren.\n";
    file.close();
    std::cout.rdbuf( sbuf );
    Framework::releaseFramework();
    return 0;
}